;
; make depth of 20C
;
FUNCTION make_20C, file_name, ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2,  ALL_DATA = all_data, ZMTYP = zmtyp

@common
@com_eg
;
;
; Read t
;
   tn = nc_read(file_name,'votemper', ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data)
;
; Compute depth of 20C isotherm (from diahth.F of OPA)
;
; ... initialization to the number of ocean w-point mbathy

   ik20c = lonarr((size(tn.data))[1], (size(tn.data))[2])
   ik20c[*, *] = 1
   hd20 = fltarr((size(tn.data))[1], (size(tn.data))[2])
   zdiv = fltarr((size(tn.data))[1], (size(tn.data))[2])

; ... search the depth of 20 degrees isotherm
;     ( starting from the top, last level above 20C, if not exist, = 1)

   FOR jk = 0, jpk-1-1 DO  BEGIN
      idx = where (tn.data[*, *, jk] GE 20)
      ik20c[idx] = jk
   ENDFOR 
   help, ik20c, tn.data, (size(tn.data))[1], (size(tn.data))[2]
   print,  ik20c[90, 64], gdept(ik20c[90, 64]), gdept(ik20c[90, 64]+1)
   print,  tn.data(90, 64, ik20c[90, 64]+1), tn.data(90, 64, ik20c[90, 64])

; depth is a linear interpolation

   hd20 = gdept(ik20c) 
   help, hd20
   print, min(hd20), max(hd20)

   FOR jj = 0, (size(tn.data))[2]-1 DO BEGIN 
      FOR ji = 0, (size(tn.data))[1]-1 DO BEGIN 
         hd20[ji, jj] =  gdept(ik20c[ji, jj]) + $
          ( gdept(ik20c[ji, jj]+1)-gdept(ik20c[ji, jj]) ) $
          * ( 20.*tmask(ji, jj, ik20c[ji, jj]+1) - tn.data(ji, jj, ik20c[ji, jj]) ) $
          / ( tn.data(ji, jj, ik20c[ji, jj]+1) - tn.data(ji, jj, ik20c[ji, jj]) ) 
      ENDFOR  
   ENDFOR 
   hd20 = min(hd20, 0)
   help, hd20
   print, min(hd20), max(hd20)


; bound by the ocean depth, minimum value, first T-point depth
;          hd20(ji,jj) = min( zd20, fsdepw(ji,jj,mbathy(ji,jj)) )

   stop

   field = {name: '', data: hd20, legend: '', units: '', origin: '', dim: 0, direc:''}
   
   field.origin = tn.origin
   field.dim = 2
   fieldr.direc = tn.direc


   return, field
END 
