;
; compute gradients along x and y on grid points T, U, V, lmdzl for any variable

FUNCTION make_grad,  file_name,  ncdf_db,  BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data, ZMTYP = zmtyp

@common
@com_eg

;  Extract the variable and the coordinate along which we want the gradients
   var_name =  (strsplit(macro_base_fld, ',', ESCAPE = ' ', /EXTRACT))[0]
   coord_name =  (strsplit(macro_base_fld, ',', ESCAPE = ' ', /EXTRACT))[1]

;  Read the variable in the correspondent netcdf file
   var =  nc_read(file_name, var_name, ncdf_db, BOXZOOM = boxzoom, TIME_1 = time_1,  TIME_2 =  time_2, ALL_DATA = all_data)

   varname =  var.name
   varunit =  var.units

;  Apply the saxo routine to compute gradients
   gradients =  grad (var.data, coord_name)
   print,  'The vargrid variable after computation of the gradients is ',  vargrid 

;  Define the outputs of the function   
   field = {name: '', data: gradients, legend: '', units: '', origin: '', dim: 0,  direc:''}   
   field.origin = var.origin
   field.dim = var.dim
   field.direc = var.direc   
   
   return, field

END
