;;;
;;;
;;;
;;;
;;;
PRO Fig_msf_sigma

@common

;meshmask 
@0_initorca2_NDV1
;
; exp name & year
	e_exp='NDV01'
	e_year='1500'
    ioDATA=iodir+e_exp

; if difference plotted:
    e_exp0='NDV02'
    e_year0='1500'
    ioDATA0=iodir+e_exp0
;
; fields to read
  file_T=e_exp+'_1y_'+e_year+'_'+e_year+'_grid_T.nc'  
  file_V=e_exp+'_1y_'+e_year+'_'+e_year+'_grid_V.nc' 
;
; title
t_exp1= e_exp
t_year= 'y'+e_year
;
t_glo = ' Global effective sMSF '
t_atl = ' Atlantic effective sMSF '
t_pac = ' Pacific effective sMSF '
t_ind = ' Indian effective sMSF '
t_ipa = ' Indo-Pacific effective sMSF '
;
t_msf = 'gMSF'
;
; Submask ORCA_R2_V2
;save, filename='IDL_DATA:DATA:submsk_orcaR2_v2.dat',atlmsk, pacmsk, indmsk, glomsk, glomsk_msf
restore, filename=iodir+'meshes/submsk_NDV1.dat'
;
; define vmask for each sub basin (mask in the ACC: MSF computation)
vglomsk = shift(tmask(*,*,0), 0, -1) *tmask(*,*,0)
atlmsk=glo_atl*glo_noACC
vatlmsk = shift(atlmsk, 0, -1) * atlmsk
pacmsk=glo_pac*glo_noACC
vpacmsk = shift(pacmsk, 0, -1) * pacmsk
indmsk=glo_ind*glo_noACC
vindmsk = shift(indmsk, 0, -1) * indmsk
ipacmsk=glo_indpac*glo_noACC
vipacmsk= shift(ipacmsk, 0, -1) * ipacmsk
;
; Loading the model output fields T, S
tpot=read_ncdf('votemper',0, /timestep, iodir=ioDATA,/nostruct,/tout, filename=file_T)
sal =read_ncdf('vosaline',0, /timestep, iodir=ioDATA,/nostruct,/tout, filename=file_T)

; lecture de series temporelle: ienr numero de l'enregistrement: (de 0 � 73, 5 jours)
; tpot=read_ncdf('votemper',ienr, ienr, /timestep, iodir=ioDATA,/nostruct, filename=file_T)

;Kicking land points out (land point <---> 1e20) 
tpot=tpot*tmask
sal=sal*tmask
; computing density (in sigma4)
; iref=4
; zsigma=eos(tpot, sal, iref)-1000.*tmask
 zsigma=eos_neutral(tpot, sal)-1000.*tmask
 
 zsc=npc(zsigma)

;
;read the effective meridional velocity and mask it
vv_dyn  =read_ncdf('vomecrty',0, /timestep, iodir=ioDATA,/nostruct,/tout, filename=file_V)
vv_gm =read_ncdf('vomeeivv',0, /timestep, iodir=ioDATA,/nostruct,/tout, filename=file_V)
vv=vv_dyn+vv_gm
;vv(where(vv GE 20))=!values.f_nan
vv=vv*vmask()

     
; Delete the cumbersome arrays
undefine, tpot
undefine, sal
undefine, vv_dyn
undefine, vv_gm

; defining density coordinate 
 sig_min = 21.
 sig_max = 28.6

; sigma 4
;	sig_min= 36.				&$
;	sig_max=47.				&$


sig_del=0.02
;sig_del=0.1
n_sig = ROUND((sig_max-sig_min)/sig_del)+1      

; define density coordinate

s_v=sig_min+findgen(n_sig)*sig_del
s_v(0) = 0.
s_v(n_sig-1) = 100.


; essai new bining avec zoom:
; sigma 4
;	sig_min1= 36.				&$
;	sig_max1= 47.				&$

;    sig_del1=  0.1

; neutral sigma


!except=0
    v_s = bin_velocity_New(zsc, s_v, vv, /vv)
; undefine, vv

; compute the msf in sigma coord. for each ocean
 phiglo= msfs(vv,zsigma,s_v,orca=2,  mask=vglomsk)
 phiatl= msfs(vv,zsigma,s_v,orca=2, mask=vatlmsk)
 phipac= msfs(vv,zsigma,s_v,orca=2, mask=vpacmsk)
 phiind= msfs(vv,zsigma,s_v,orca=2, mask=vindmsk)
 phiipa= msfs(vv,zsigma,s_v,orca=2, mask=vipacmsk)

;save, filename=ioDATA+'/'+e_exp+'_'+t_year+t_msf+'.dat',phiglo, phiatl, phipac, phiind, phiipa
save, filename=ioDATA+'/'+e_exp+'_'+t_year+t_msf+'_sig4.dat',phiglo, phiatl, phipac, phiind, phiipa

; prepare plots:
orca = 2
varname='Meridional Stream Function'
varunit='Sv'
vargrid='W'


jpk=n_elements(s_v)
gdept=[min(s_v)-2*sig_del,s_v]
gdepw=[min(s_v)-2*sig_del,s_v]+sig_del
e3t=replicate(1,jpk)
e3w=replicate(1,jpk)
tmask=replicate(1b,jpi,jpj,jpk)
domdef,0,jpi-1,0,jpj-1,0,jpk-1,/index


if keyword_set(orca) then begin            &$
	case orca of                       &$
		2:ixref=51-1               &$
		.5:ixref=204-1             &$
		.25:ixref=408-1            &$
		else:ixref=0               &$
        endcase                            &$
	ixref=ixref-ixminmesh              &$
	ixref=ixref+key_shift              &$
	ixref=ixref mod jpi                &$
	if ixref lt 0 then ixref=ixref+jpi &$
endif else ixref=0                         &$
domdef,ixref,ixref,0,jpj-1,0,jpk-1,/index,grille=['T','W']


;
;
;openps, t_exp1+'_'+t_year+'_'+t_msf+'sig4c.ps'
openps, t_exp1+'_'+t_year+'_'+t_msf+'signeu.ps'
 z_ext=[-30.,30.,2.]
 zboite=[21,28.6]     
 zzoom=27.6
;     zboite=[36.,46.5]
;     zzoom=45.4
pltz, phiglo, boite=zboite, min=z_ext[0], max=z_ext[1], int=z_ext[2], hzsurht=0.3, zoom=zzoom,$
	petit=[2,2,1], /landscape, /nocolor, lct=64, /rempli, ytitle='gamma',$
	title=t_exp1+t_glo+t_year
z_ext=[-20.,20.,1.]
pltz, phiatl, boite=zboite, min=z_ext[0], max=z_ext[1], int=z_ext[2], hzsurht=0.3, zoom=zzoom,$
	petit=[2,2,2], /noerase, /nocolor,lct=64, /rempli, ytitle='gamma',$
	title=t_exp1+t_atl+t_year
pltz, phipac, boite=zboite,min=z_ext[0], max=z_ext[1], int=z_ext[2], hzsurht=0.3, zoom=zzoom,$
	petit=[2,2,3], /noerase, /nocolor, lct=64, /rempli, ytitle='gamma',$
	title=t_exp1+t_pac+t_year
pltz, phiind, boite=zboite,min=z_ext[0], max=z_ext[1], int=z_ext[2], hzsurht=0.3, zoom=zzoom,$
	petit=[2,2,4], /noerase, /nocolor, lct=64, /rempli, ytitle='gamma',$
	title=t_exp1+t_ind+t_year

closeps



;
; plot the difference 
; � faire apres avoir calcul� et sauv� les 2 calculs 
; penser � refaire le domdef et ce qui le precede
restore, filename=ioDATA0+'/'+e_exp0+'_'+t_year+t_msf+'_sig4.dat'
phiglo0=phiglo
phiatl0=phiatl
phipac0=phipac
phiind0=phiind
restore, filename=ioDATA+'/'+e_exp+'_'+t_year+t_msf+'_sig4.dat'
openps, t_exp1+'-'+e_exp0+'_'+t_year+'_'+t_msf+'.ps'
;zboite=[45.4,46.5]
     zboite=[36.,46.5]
     zzoom=45.4
z_ext=[-10.,10.,1.0]
pltz, phiglo-phiglo0, boite=zboite, zoom=zzoom, min=z_ext[0], max=z_ext[1], int=z_ext[2], $
	petit=[2,2,1], /landscape, /nocolor, lct=64, /rempli, ytitle='sigma 4',$
	title=t_exp1+'-'+e_exp0+'+t_glo+t_year'
pltz, phiatl-phiatl0, boite=zboite, zoom=zzoom,min=z_ext[0], max=z_ext[1], int=z_ext[2], $
	petit=[2,2,2], /landscape, /nocolor, lct=64, /rempli, ytitle='sigma 4',$
	title=t_exp1+'-'+e_exp0+'+t_atl+t_year', /noerase
pltz, phipac-phipac0, boite=zboite, zoom=zzoom,min=z_ext[0], max=z_ext[1], int=z_ext[2], $
	petit=[2,2,3], /landscape, /nocolor, lct=64, /rempli, ytitle='sigma 4',$
	title=t_exp1+'-'+e_exp0+'+t_pac+t_year', /noerase
pltz, phiind-phiind0, boite=zboite, zoom=zzoom,min=z_ext[0], max=z_ext[1], int=z_ext[2], $
	petit=[2,2,4], /landscape, /nocolor, lct=64, /rempli, ytitle='sigma 4',$
	title=t_exp1+'-'+e_exp0+'+t_ind+t_year', /noerase

closeps

; reninitialiser la grille z
;@initorca2_o
@0_initorca2_NDV1






